
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用Dynamips构建能够与真实机器通信的IPSec VPN环境 / 憋错料</title>

    <meta name="description" content="用Dynamips构建能够与真实机器通信的IPSec VPN环境 一.问题 手头没有支持IPSec的路由器设备,但是想构建IPSec VPN环境,并截取IPSec数据进行协议的学习分析,怎么办? 二.解决思路 利用Dynamips模拟支持IPSec的路由器,将模拟出来的路由器接口绑定到Linux虚拟网卡上,并依托网桥技术使虚拟网卡能够与实际网卡进行通信.在上述基础环境构建完毕的基础上,配置IPSec VPN,然后在路由器接口(即虚拟网卡)上嗅探获取IPSec通信数据. 三.模拟环境构建 图一 模拟环境示意图 根据上面的解决思路,拟构建的模拟环境如上图所示.在R">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">用Dynamips构建能够与真实机器通信的IPSec VPN环境</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一、问题</strong></p>
<p>手头没有支持IPSec的路由器设备，但是想构建IPSec VPN环境，并截取IPSec数据进行协议的学习分析，怎么办？</p>
<p><strong>二、解决思路</strong></p>
<p>利用Dynamips模拟支持IPSec的路由器，将模拟出来的路由器接口绑定到Linux虚拟网卡上，并依托网桥技术使虚拟网卡能够与实际网卡进行通信。在上述基础环境构建完毕的基础上，配置IPSec VPN，然后在路由器接口（即虚拟网卡）上嗅探获取IPSec通信数据。</p>
<p><strong>三、模拟环境构建</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzQvNDcvd0tpb20xWVhzb2J5YjVMd0FBQi1TQnJaaXY4NjIyLmpwZw==.jpg" /></p>
<p>图一 模拟环境示意图</p>
<p>根据上面的解决思路，拟构建的模拟环境如上图所示。在R1和R2之间构建隧道模式的IPSec VPN，PC1和PC2之间的通信数据在进入R1、R2时自动被封装成IPSec数据，在流出R1、R2时自动解封成明文的IP数据包。要将上图的模拟环境落到实处，我们需要三台机器PC1、PC2、PC3（可以是三台虚拟机），其中PC3要求为Linux操作系统，有三张网卡，且支持网桥和TAP虚拟网卡，同时能够正常运行Dynamips，另外两台（对应上图的PC1、PC2）没有特殊要求，只要是PC机即可。</p>
<p>模拟环境中涉及了很多虚拟的东西，如路由器、网卡、网桥等，理解起来比较艰涩。为了方便理解，给出一个全景的逻辑视图。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzQvNDcvd0tpb20xWVhzc1RTMzA1LUFBSFdMNHBuUXljMzQ3LmpwZw==.jpg" /></p>
<p><img src="/e/u261/themes/default/images/spacer.gif" />图二 模拟环境逻辑视图</p>
<p>对图二的说明如下：</p>
<p>1、红色椭圆中的要素都运行在PC3（Linux）上</p>
<p>2、虚线是数据通信的逻辑效果，与图一一致</p>
<p>3、实线代表的是数据的实际流向。决定数据实际如此流向的是因为，tap虚拟网卡和eth真实网卡都是网络接口，具有一定的独立性，需要网桥进行桥接通信。但同时tap虚拟网卡是虚拟的，它不能脱离真实网卡而存在，所以在同一网桥下至少有一个真实网卡，以承载实际的数据通信功能。</p>
<p><strong>四、具体配置实践</strong></p>
<p>有了上面的理论基础，接下来就开始动手实践。先从最复杂的PC3（Linux）开始，然后再配置PC1、PC2。</p>
<p><strong>1、PC3（Linux）配置</strong></p>
<p>Dynamips、网桥（brctl）、三张网卡（建议用虚拟机，很方便）等先决条件请自行解决，然后按如下步骤进行</p>
<p><strong>①配置网桥和虚拟网卡</strong></p>
<p>brctl addbr br0</p>
<p>brctl addbr bR1</p>
<p>brctl addbr bR2</p>
<p>（说明：添加br0、bR1、bR2三个网桥）</p>
<p>ip l s dev br0 up</p>
<p>ip l s dev bR1&nbsp;up</p>
<p>ip l s dev bR2&nbsp;up</p>
<p>（说明：启动网桥）</p>
<p>tunctl -t tap0 -u root</p>
<p>tunctl -t tap1 -u root</p>
<p>tunctl -t tap2 -u root</p>
<p>tunctl -t tap3 -u root</p>
<p>（说明：添加虚拟网卡）</p>
<p>ip l s dev tap0 up</p>
<p>ip l s dev tap1 up</p>
<p>ip l s dev tap2 up</p>
<p>ip l s dev tap3 up</p>
<p>（说明：启动虚拟网卡）</p>
<p>brctl addif br0 tap0</p>
<p>brctl addif br0 eth0</p>
<p>brctl addif bR1&nbsp;tap1</p>
<p>brctl addif bR1&nbsp;tap3</p>
<p>brctl addif bR1&nbsp;eth1</p>
<p>brctl addif bR2&nbsp;tap2</p>
<p>brctl addif bR2&nbsp;eth2</p>
<p>（说明：把网卡和虚拟网卡添加到对应的网桥）</p>
<p>ifconfig eth0 0.0.0.0 promisc</p>
<p>ifconfig eth1 0.0.0.0 promisc</p>
<p>ifconfig eth2 0.0.0.0 promisc</p>
<p>（说明：把网卡设置成混杂模式）</p>
<p><strong>②模拟路由器R1、R2</strong></p>
<p>dynamips -P 2691 -s 0:0:tap:tap0 -s 0:1:tap:tap1 ../c2691-adventerprisek9-mz.124-25d.bin</p>
<p>dynamips -P 2691 -s 0:0:tap:tap2 -s 0:1:tap:tap3 ../c2691-adventerprisek9-mz.124-25d.bin</p>
<p>（说明：分别模拟运行了路由器R1、R2，R1的0/0接口和tap0绑定，其他类似）</p>
<p>对R1配置如下：</p>
<p>R1(config)#int fa0/0</p>
<p>R1(config-if)#ip add 192.168.2.1 255.255.255.0</p>
<p>R1(config-if)#no sh</p>
<p>R1(config-if)#exit</p>
<p>R1(config)#int fa0/1</p>
<p>R1(config-if)#ip add 10.0.0.1 255.255.255.0</p>
<p>R1(config-if)#no sh</p>
<p>R1(config-if)#exit</p>
<p>R1(config)#ip route 0.0.0.0 0.0.0.0 10.0.0.2</p>
<p>R1(config)#end</p>
<p>对R2配置如下：</p>
<p>R2(config)#int fa0/0</p>
<p>R2(config-if)#ip add 192.168.3.1 255.255.255.0</p>
<p>R2(config-if)#no sh</p>
<p>R2(config-if)#exit</p>
<p>R2(config)#int fa0/1</p>
<p>R2(config-if)#ip add 10.0.0.2 255.255.255.0</p>
<p>R2(config-if)#no sh</p>
<p>R2(config-if)#exit</p>
<p>R2(config)#ip route 0.0.0.0 0.0.0.0 10.0.0.3</p>
<p>R2(config)#end</p>
<p><strong>③配置IPSec VPN</strong></p>
<p>在R1上配置IKE（ISAKMP）策略:</p>
<p>R1(config)#crypto isakmp policy 1</p>
<p>R1(config-isakmp)#encryption 3des</p>
<p>R1(config-isakmp)#hash sha</p>
<p>R1(config-isakmp)#authentication pre-share</p>
<p>R1(config-isakmp)#group 2</p>
<p>R1(config-isakmp)#exit</p>
<p>说明：定义了ISAKMP policy 1，加密方式为3des，hash算法为sha，认证方式为Pre-Shared Keys (PSK)，密钥算法（Diffie-Hellman）为group 2。</p>
<p>在R1上定义认证标识:</p>
<p>R1(config)#crypto isakmp key 0 cisco123 address 10.0.0.2</p>
<p>说明：因为之前定义的认证方式为Pre-Shared Keys (PSK)，所以需要定义认证密码，这里定义与peer 10.0.0.2的认证密码为cisco123，并且双方密码必须一致，否则无法建立IKE SA，其中0表示密码在running-config中显示为明文。</p>
<p>在R1上配置IPsec transform:</p>
<p>R1(config)#crypto ipsec transform-set ccie&nbsp;ah-sha-hmac&nbsp;esp-3des esp-sha-hmac</p>
<p>R1(cfg-crypto-trans)#exit</p>
<p>说明：配置了transform-set为ccie，认证协议使用ah，其实esp也有认证功能，可以去掉ah，单独使用esp。其中数据封装使用esp加3des加密，并且使用esp结合sha做hash计算，默认的IPsec mode为tunnel。</p>
<p>在R1上定义感兴趣流量:</p>
<p>R1(config)#access-list 100 permit ip 192.168.2.0 0.0.0.255 192.168.3.0 0.0.0.255</p>
<p>说明：这里需要被IPsec保护传输的流量为.2网段至.3网段的流量，即192.168.2.0/24发往192.168.3.0/24的流量，切记不可使用any来表示地址。</p>
<p>在R1上创建crypto map:</p>
<p>R1(config)#crypto map l2l 1 ipsec-isakmp</p>
<p>R1(config-crypto-map)#set peer 10.0.0.2</p>
<p>R1(config-crypto-map)#set transform-set ccie</p>
<p>R1(config-crypto-map)#match address 100</p>
<p>R1(config-crypto-map)#exit</p>
<p>说明：在R1上配置crypto map为l2l，序号为1，即第1组策略，其中指定加密数据发往的对端为10.0.0.2，即和10.0.0.2建立IPsec隧道，调用的IPsec transform为ccie，并且指定ACL 100中的流量为被保护的流量。</p>
<p>在R1上将crypto map应用于接口:</p>
<p>R1(config)#int f0/1</p>
<p>R1(config-if)#crypto map l2l</p>
<p>R1(config-if)#exit</p>
<p>R1(config)#</p>
<p>说明：将crypto map应用在去往192.168.3.0/24的接口F0/0上。</p>
<p>使用相同方式配置R3的LAN-to-LAN VPN:</p>
<p>R2(config)#crypto isakmp policy 1</p>
<p>R2(config-isakmp)#encryption 3des</p>
<p>R2(config-isakmp)#hash sha</p>
<p>R2(config-isakmp)#authentication pre-share</p>
<p>R2(config-isakmp)#group 2</p>
<p>R2(config-isakmp)#exit</p>
<p>R2(config)#crypto isakmp key 0 cisco123 address 10.0.0.1</p>
<p>R2(config)#crypto ipsec transform-set ccie&nbsp;ah-sha-hmac&nbsp;esp-3des esp-sha-hmac</p>
<p>R2(cfg-crypto-trans)#exit</p>
<p>R2(config)#access-list 100 permit ip 192.168.3.0 0.0.0.255 192.168.2.0 0.0.0.255</p>
<p>R2(config)#crypto map l2l 1 ipsec-isakmp</p>
<p>R2(config-crypto-map)#set peer 10.0.0.1</p>
<p>R2(config-crypto-map)#set transform-set ccie</p>
<p>R2(config-crypto-map)#match address 100</p>
<p>R2(config-crypto-map)#exit</p>
<p>R2(config)#</p>
<p>R2(config)#int f0/1</p>
<p>R2(config-if)#crypto map l2l</p>
<p>R2(config-if)#</p>
<p>*Mar &nbsp;1 00:32:58.907: %CRYPTO-6-ISAKMP_ON_OFF: ISAKMP is ON</p>
<p>R2(config-if)#</p>
<p>说明：R2与R1的IKE和IPsec策略必须保持一致。</p>
<p><strong>2、配置PC1和PC2</strong></p>
<p>假设PC1和PC2都是Windows操作系统，设置其IP分别为192.168.2.22、192.168.3.33，然后分别添加一条路由</p>
<p>route add 192.168.3.0 mask 255.255.255.0 192.168.2.1</p>
<p>route add 192.168.2.0 mask 255.255.255.0 192.168.3.1</p>
<p><strong>五、测试</strong></p>
<p>在PC3（Linux）上运行wireshark抓取tap1接口的数据，在PC1上也运行wireshark抓取网卡的数据，然后在PC2上ping PC1。PC3（Linux）和PC1上wireshark的抓取截图分别如图三、和图四。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzQvNDcvd0tpb20xWVhzeHFDeV8wZUFBZkZCUV80Z1lnMTQ3LmpwZw==.jpg" /></p>
<p>图三 PC3（Linux）上wireshark截图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzQvNDcvd0tpb20xWVhzNC1nRFc2WUFBYTFLVUFZOFRBMTUzLmpwZw==.jpg" /></p>
<p>图四 PC1上wireshark截图</p>
<p>图三中，抓取的是tap1虚拟网卡的数据，tap1对应R1的fa0/1接口，是IPSec VPN隧道的其中一个端点，其对应的数据应该是IPSec密数据，图三的结果印证了这一点。</p>
<p>图四中，抓取的是PC1上的数据，PC1上的数据已经离开IPSec VPN隧道，得到的应该是明文数据，图四的结果也印证了这一点。</p>
<p>好了，打完收工。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 00:11:34 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ipsec/" title="ipsec">ipsec</a>, <a href="https://www.biecuoliao.com/tag/%e8%99%9a%e6%8b%9f%e7%bd%91%e5%8d%a1/" title="虚拟网卡">虚拟网卡</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>用Dynamips构建能够与真实机器通信的IPSec VPN环境的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J8rZB0.html" rel="bookmark">烂泥：openvpn双网卡客户端与内网机器通信</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前段时间写了一篇有关openvpn搭建与内网机器通信的文章,那篇文章是基于服务器单网卡进行配置的,文章链接为&lt;烂泥:openvpn tun模式下客户端与内网机器通信&gt;. 这篇文章我们再来介绍下双网卡openvpn客户端与内网机器通信的配置. 一.需求说明 为什么要写openvpn双卡的配置? 是因为一般IDC机房都是提供多网卡服务器,同时目前比较流行的云服务器阿里云提供的也是双网卡,而腾讯云以及亚马逊的aws都是单网卡.各个云服务器商的网卡配置个数,如下图: 二.业务要求 现在IDC机房那边有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzBvolM.html" rel="bookmark">烂泥：openvpn tun模式下客户端与内网机器通信</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文由秀依林枫提供友情赞助,首发于烂泥行天下 前两篇文章我们介绍了有关openvpn的搭建与配置文件的讲解,这篇文章我们再聊介绍下,在tun模式下openvpn客户端如何与内网机器通信的问题. 一.实际问题 先来介绍下目前的基本情况,如下: 1.openvpn服务器单网卡,通过硬件防火墙把openvpn服务器的1194端口映射到公网. 2.openvpn服务器所在的网段为192.168.5.1/24网段 3.openvpn客户端获得IP地址为10.8.0.1/24网段 要求10.8.0.1/24			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qRgVG4.html" rel="bookmark">构建第一个驱动程序（一）之Linux环境配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				构建第一个驱动程序(一)之Linux环境配置 一.超级终端的使用 软件:hypertem超级终端 打开软件后弹出 点击&quot;取消&quot; 弹出 点击&quot; 是&quot; 弹出&quot;新建连接&quot; 填写名称 点击 &quot;确定&quot;,又弹出之前的位置信息,忽略他. 直到弹出&quot;连接到&quot; 选择你自己板子连接的串口,我的是COM4 确定后,按下图设置 ,按下任意键顺利出现 连接成功. 二.交叉编译环境的安装及配置首先下载交叉编译工具链,这里提供笔者使用的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Ozer90.html" rel="bookmark">构建Docker镜像实战之构建Tomcat9&period;0镜像（RPM一键安装Java环境）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				构建Docker镜像实战之构建Tomcat9.0镜像(RPM一键安装Java环境) tomcat是一个免费开源的轻量级web服务器,在中小型企和并发访问量不高的场合普遍使用,是开发和调试JSP程序的首选.下面使用Dockerfile文件的方式来创建带有tomcat服务的Dockerfile镜像.(注:这里的Java环境是使用rpm一键式安装的且小编创建的是tomcat9.0的镜像) 下面直接开始实验 关闭防火墙及SELinux systemctl stop firewalld.service s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xpYzN0.html" rel="bookmark">一个服务跑在容器里和跑在真实机器的区别&lpar;详解&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				每条都很精炼 物理机 容器 运行一个独立的服务 直接运行在物理机上,你需要物理硬件(CPU,内存,磁盘等等),还有操作系统,然后安装该服务程序然后启动 你只需挑选一台物理机安装docker环境并启动,将这个服务的官方镜像拉取下来,然后运行容器 持续部署和测试 达不到线下线上环境一致性,就算在测试环境测试无误,部署到生产环境也可能出现各种环境适配问题 如开发代码部署完,基于代码构建docker镜像,测试环境测试好之后,那么生产环境也不会出什么问题 版本控制 基于代码进行版本控制 直接将代码融合到镜			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qBvGD4.html" rel="bookmark">zabbix 内网机器通信状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				a=0 for xgip in ${xgipset[*]} do let a+=1 fping $xgip|grep alive &gt;/dev/null if [ $a != 3 ];then if [ $? = 0 ];then echo -n &quot;$outip与$xgip正常通信,&quot; else echo -n &quot;$outip与$xgip不可达,&quot; fi else if [ $? = 0 ];then echo &quot;$outip与$xgip正常通信,&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmNVyB0.html" rel="bookmark">Eclipse 连接真实机器调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.手机开启调试模式 二.安装adb.exe 1.确信 \android-sdk-windows\tools\下有 adb.exe     AdbWinApi.dll     AdbWinUsbApi.dll 三个文件,如果没有从\android-sdk-windows\platform-tools\ 下面拷贝到tools下  2.windows的话 进入android-sdk-windows\tools目录  如下图执行安装    出来一堆英文表示安装成功   3.adb devices命令产			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rQPDl0.html" rel="bookmark">思科设备路由器间IPsec VPN实现私网之间通信实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.       实验拓扑: 使用GNS3(版本号0.8.6)+c2691-advsecurityk9-mz.124-11.T2. 2.       实验需求: a)       C1可以和C2通信,实现跨互联网私网通信 b)       C1.C2可以和R2的环回口loopback0通信,实现C1.C2及可以私网通信也可以上公网 3.       实验步骤: a)       IP地址规划 R1 f0/0 12.0.0.1/24 R3 f0/0 23.0.0.3/24 f0/1 172.16.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVGnBx0.html" rel="bookmark">构建调试Linux内核&lpar;32位&rpar;网络代码的环境MenuOS系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一步:下载,编译linux内核 mkdir LinuxKernel cd LinuxKernel wget https://mirror.bjtu.edu.cn/kernel/linux/kernel/v5.x/linux-5.0.1.tar.xz xz -d linux-5.0.1.tar.xz tar -xvf linux-5.0.1.tar cd linux-5.0.1 sudo apt install build-essential flex bison libssl-dev libe			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47w7b4.html" rel="bookmark" class="title">import导入模块 【python】</a>
					<div>
						模块的使用:通过import导入模块,然后按照&quot;模块.函数&quot;的格式使用模块的函数. 如: &gt;&gt;&gt; import math &gt;&gt;&gt; math.fl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RaavM.html" rel="bookmark" class="title">Batch containing 1 record&lpar;s&rpar; expired due to timeout while requesting metadata from brokers</a>
					<div>
						一.异常信息如下: java.util.concurrent.ExecutionException: org.apache.kafka.common.errors.TimeoutException:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MExnZ4.html" rel="bookmark" class="title">&lbrack;读书笔记&rsqb;Java类加载器</a>
					<div>
						一.类与类加载器 类加载器除了在类加载阶段的作用外,还确定了对于一个类,都需要由加载它的类加载器和这个类本身一同确定其在Java虚拟机中的唯一性.通俗一点来讲,要判断两个类是否&quot;相等&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGNyr4.html" rel="bookmark" class="title">html5学习之路&lowbar;004</a>
					<div>
						HTML表单 表单用于获取不同类型的用户输入 常用表单标签 下面为一个简单的表单: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head lang=&quot;en& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YY9pw0.html" rel="bookmark" class="title">寒江独钓Windows内核编程&mdash;&mdash;串口过滤</a>
					<div>
						一.过滤的概念: 过滤是在不影响上层和下层接口的情况下,在Windows系统内核中加入新的层,从而不需要修改上层的软件或者下层的真是驱动程序,就加入了新的功能. 1.1 设备绑定的内核API 进行过滤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGlzbM.html" rel="bookmark" class="title">Android平台调用Web Service：引入线程</a>
					<div>
						接上文 遗留问题 MainActivity的onCreate方法中如果没有有这段代码: // 强制在UI线程中操作 StrictMode.setThreadPolicy(new StrictMode. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOYoX3.html" rel="bookmark" class="title">java八大基本数据类型</a>
					<div>
						1.void可不算八种基本类型中. 2.若类的某个成员是基本数据类型,即使没有进行初始化,java也会确保它获得一个默认值,当变量作为类的成员使用时,java才确保给定其默认值,已确保那些是基本类型的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXPa74.html" rel="bookmark" class="title">ASP&period;NET MVC 随想录&mdash;&mdash;  使用ASP&period;NET Identity实现基于声明的授权，高级篇</a>
					<div>
						在这篇文章中,我将继续ASP.NET Identity 之旅,这也是ASP.NET Identity 三部曲的最后一篇.在本文中,将为大家介绍ASP.NET Identity 的高级功能,它支持声明式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONrKZ0.html" rel="bookmark" class="title">Python简易web服务</a>
					<div>
						利用Python自带的包可以建立简单的web服务器.在DOS里cd到准备做服务器根目录的路径下,输入命令: python -m Web服务器模块 [端口号,默认8000] 例如: python -m  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWj164.html" rel="bookmark" class="title">Redis学习笔记&lpar;9&rpar;-管道&sol;分布式</a>
					<div>
						package cn.com; import java.util.Arrays; import java.util.List; import redis.clients.jedis.Jedis; im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dN5qw4.html" rel="bookmark" class="title">Android开发 详解开源项目CircleImageView</a>
					<div>
						之前的项目中在需要显示圆形头像的地方,使用到了Github上的优秀开源项目CircleImageView https://github.com/hdodenhof/CircleImageView 今天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnmKQ3.html" rel="bookmark" class="title">&lbrack;Everyday Mathematics&rsqb;20150104</a>
					<div>
						设 $a&gt;0$, $$\bex x_1=1,\quad x_{n+1}=x_n+an\prod_{i=1}^n x_i^{-\frac{1}{n}}. \eex$$ 试证: $$\bex \vl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrqgB4.html" rel="bookmark" class="title">NET中IL指令详解</a>
					<div>
						名称 说明 Add 将两个值相加并将结果推送到计算堆栈上. Add.Ovf 将两个整数相加,执行溢出检查,并且将结果推送到计算堆栈上. Add.Ovf.Un 将两个无符号整数值相加,执行溢出检查,并且 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmR6nM.html" rel="bookmark" class="title">JavaScript垃圾回收（三）&mdash;&mdash;内存泄露</a>
					<div>
						一.JavaScript内存监测工具 在讨论内存泄露之前,先介绍几款JavaScript内存监测工具. IE的sIEve与JSLeaksDetector(这两个可以在下面的附件中下载),firefox ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41G7PP0.html" rel="bookmark" class="title">HDU5979 Convex</a>
					<div>
						1 /* 2 HDU5979 Convex 3 http://acm.hdu.edu.cn/showproblem.php?pid=5979 4 计算几何 三角形面积公式 5 * 6 * 7 */ 8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzX88d3.html" rel="bookmark" class="title">Swift2&period;1 语法指南&mdash;&mdash;析构过程</a>
					<div>
						原档:https://developer.apple.com/library/prerelease/ios/documentation/Swift/Conceptual/Swift_Programmi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l9ANL3.html" rel="bookmark" class="title">C&plus;&plus; MPICH</a>
					<div>
						如果一个C++的MPI程序在单机上可以跑,但是在多机上跑会报以下错误: Fatal error in MPI_Send: Unkown error class , error stack. 解决方法: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWknO4.html" rel="bookmark" class="title">横瓜先生纵论NOSQL与MYSQL实现最热最新查询的分页性能比较</a>
					<div>
						[状元]横瓜-PHP教父(601069289)  20:45:59 大家谈谈NOSQL与MYSQL的差距 NOSQL与MYSQL实现最热最新查询的分页性能比较 MYSQL千亿级要优化的,用起来的不敏捷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzD8kA3.html" rel="bookmark" class="title">mysql中递归树状结构&amp;lt&semi;转&amp;gt&semi;</a>
					<div>
						在Oracle 中我们知道有一个 Hierarchical Queries 通过CONNECT BY 我们可以方便的查了所有当前节点下的所有子节点.但很遗憾,在MySQL的目前版本中还没有对应的功能. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YmZYO0.html" rel="bookmark" class="title">Xilium&period;CefGlue CEF Chrome 自动上传文件不弹出对话框 CefDialogHandler</a>
					<div>
						关键代码如下,如何使用Handler,还不清楚的请继续搜索 internal sealed class WyzCefDialogHandler : CefDialogHandler    {      ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
